; Compile with 'asm examples/hello_world_boot.asm'
; Start with 'qemu-system-i386 -fda examples/hello_world_boot'

#16bit							; generate 16bit code 

func print(si) (				; function "print" with one parameter in register "si", functions are automatically appended after the code
	ah = 0x0E					; Interrupt number to print character
	bh = 0
	do (						; loop
		lodsb					; al = character in si
		int 0x10				; BIOS-interrupt
	) jmp al != 0				; loop until al = 0 (= end of string)
)

global byte empty(470) = 0		; fill up the 512bytes, globals are automatically appended after the code
global word signatur = 0xAA55	; boot signature

ax = 0x07C0 -> ds 				; set ds
if = 0							; disable interrupts
df = 0							; direction flag = 0 (for printing strings)
call print(@"Hello World\n")	; call function to print string, string is appended together with globals

do (							; infinite loop
)