; Predefined constants:
ax = $length; The length of the file
ax = $data	; The start of the data section in the file
ax = $bss   ; The start of the bss section in the file
ax = $func  ; Where functions are stored in the file

; String constants:
rax = "Hello\n"

; Setting/clearing flags:
cf = 1		; set carry flag (stc)
cf = 0		; clear carry flag (clc)
if = 1		; set interrupt flag (sti)
df = 1		; set direction flag (std)

; In/Out
in 20,al	;Input byte from port 20 to al
in 20,ax	;Input word
in 20,eax	;Input dword
in dx,eax	;Input dword from port specified by dx
out al,20	;Output byte al to port 20
out ax,dx	;Output word ax to port specified by dx

; Push/pop:
push rax
pop rax
pushf		;Push flags	(pushfd, pushfq)
popf		;Pop flags	(popfd, popfq)
pusha		;Push gp-registers (pushad, pushaq)
popa		;Pop gp-registers (popad, popaq)

; String stuff
lodsb
lodsw
lodsd
lodsq
movsq
scasq
cmpsq
stosq
rep lodsb

; Interrupts/syscalls:
int 0x10
iret
syscall
sysenter
sysexit
sysret

; Tables:
lgdt	;Global descriptor table
sgdt
lldt	;Local descriptor table
sldt
lidt	;Interrupt descriptor table
sidt

; Misc:
nop
hlt
ud
cpuid
rdrand
rdseed
lzcnt
tzcnt
rdmsr
wrmsr
lmsw
smsw
ltr
str
ldmxcsr
stmxscr